"use strict";
var __await = (this && this.__await) || function (v) { return this instanceof __await ? (this.v = v, this) : new __await(v); }
var __asyncGenerator = (this && this.__asyncGenerator) || function (thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
    function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
    function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
    function fulfill(value) { resume("next", value); }
    function reject(value) { resume("throw", value); }
    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
};
Object.defineProperty(exports, "__esModule", { value: true });
/* @internal */
class IterateAsyncIterable {
    constructor(f, x) {
        this.f = f;
        this.x = x;
    }
    [Symbol.asyncIterator]() {
        return iterateAsync(this.f, this.x);
    }
}
exports.IterateAsyncIterable = IterateAsyncIterable;
/* @internal */
class AsyncFromIterable {
    constructor(xs) {
        this.xs = xs;
    }
    [Symbol.asyncIterator]() {
        return fromIterableAsync(this.xs);
    }
}
exports.AsyncFromIterable = AsyncFromIterable;
function iterateAsync(f, x) {
    return __asyncGenerator(this, arguments, function* iterateAsync_1() {
        while (true) {
            yield yield __await(x);
            x = yield __await(f(x));
        }
    });
}
function fromIterableAsync(xs) {
    return __asyncGenerator(this, arguments, function* fromIterableAsync_1() {
        for (const x of xs) {
            yield yield __await(yield __await(x));
        }
    });
}
