"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/* @internal */
class IterateIterable {
    constructor(f, x) {
        this.f = f;
        this.x = x;
    }
    [Symbol.iterator]() {
        return iterate(this.f, this.x);
    }
}
exports.IterateIterable = IterateIterable;
function* iterate(f, x) {
    while (true) {
        yield x;
        x = f(x);
    }
}
