"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/* @internal */
class FilterIterable {
    constructor(p, xs) {
        this.p = p;
        this.xs = xs;
    }
    [Symbol.iterator]() {
        return filter(this.p, this.xs);
    }
}
exports.FilterIterable = FilterIterable;
function* filter(p, xs) {
    for (const x of xs) {
        if (p(x)) {
            yield x;
        }
    }
}
